/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.sync.controller;

import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.sync.entity.Sync;
import org.springblade.modules.sync.vo.SyncVO;
import org.springblade.modules.sync.wrapper.SyncWrapper;
import org.springblade.modules.sync.service.ISyncService;
import org.springblade.core.boot.ctrl.BladeController;
import org.springframework.web.client.RestTemplate;

import java.net.URI;
import java.util.HashMap;
import java.util.Map;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2020-11-14
 */
@RestController
@AllArgsConstructor
@RequestMapping("sync/sync")
@Api(value = "", tags = "接口")
public class SyncController extends BladeController {

	private ISyncService syncService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入sync")
	public R<SyncVO> detail(Sync sync) {
		Sync detail = syncService.getOne(Condition.getQueryWrapper(sync));
		return R.data(SyncWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入sync")
	public R<IPage<SyncVO>> list(Sync sync, Query query) {
		IPage<Sync> pages = syncService.page(Condition.getPage(query), Condition.getQueryWrapper(sync));
		return R.data(SyncWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入sync")
	public R<IPage<SyncVO>> page(SyncVO sync, Query query) {
		IPage<SyncVO> pages = syncService.selectSyncPage(Condition.getPage(query), sync);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入sync")
	public R save(@Valid @RequestBody Sync sync) {
		return R.status(syncService.save(sync));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入sync")
	public R update(@Valid @RequestBody Sync sync) {
		return R.status(syncService.updateById(sync));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入sync")
	public R submit(@Valid @RequestBody Sync sync) {
		return R.status(syncService.saveOrUpdate(sync));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(syncService.deleteLogic(Func.toLongList(ids)));
	}



	/**
	 * 新增
	 */
	@PostMapping("/test")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "测试", notes = "传入sync")
	public R<String> test(@Valid @RequestBody Sync sync) {
		System.out.println(sync);
		RestTemplate restTemplate = new RestTemplate();
		ResponseEntity responseEntity = null;
		//处理请求头参数
		HttpHeaders headers = new HttpHeaders();
		String headersPs= sync.getHeaders();
		JSONArray headersArray = JSON.parseArray(headersPs);
		for(int i=0;i<headersArray.size();i++){
			JSONObject object = headersArray.getJSONObject(i);
			headers.add(object.getString("key"),object.getString("value"));
		}
		//处理请求体
		Map<String, Object> map = new HashMap<>();
		String bodyPs = sync.getBodys();
		JSONArray bodysArray = JSON.parseArray(bodyPs);
		for(int i=0;i<bodysArray.size();i++){
			JSONObject object = bodysArray.getJSONObject(i);
			map.put(object.getString("key"),object.get("value"));
		}



		HttpEntity<String> requestEntity = new HttpEntity<String>(JSONUtil.toJsonStr(map), headers);
		ParameterizedTypeReference<Object> reference = new ParameterizedTypeReference<Object>() {
		};
		String paramsPs= sync.getParams();
		JSONArray paramsArray = JSON.parseArray(paramsPs);
		StringBuffer stringBuffer = new StringBuffer();
		for(int i=0;i<paramsArray.size();i++){
			JSONObject object = paramsArray.getJSONObject(i);
			String param = object.get("key").toString()+"="+object.get("value").toString();
			if(i==0){
				stringBuffer.append("?"+param);
			}else{
				stringBuffer.append("&"+param);
			}
		}
		String url = sync.getUrl()+stringBuffer.toString();
		URI uri = URI.create(url);
		if(sync.getMethod() ==1){
			responseEntity = restTemplate.exchange(uri, HttpMethod.POST, requestEntity, reference);
		}else{
			responseEntity = restTemplate.exchange(uri,HttpMethod.GET,requestEntity,reference);
		}



		return R.data(responseEntity.getBody().toString());
	}
}
